/*
 * path.h
 *
 * directions, paths, etc.
 *
 * $Revision: 2.1 $ $Date: 1995/09/27 23:16:23 $
 */

#ifndef _PATH_H_
#define _PATH_H_

#include "prototype.h"
#include "sect.h"

	/* direction indices */
#define	DIR_STOP	0
#define	DIR_UR		1
#define	DIR_R		2
#define	DIR_DR		3
#define	DIR_DL		4
#define	DIR_L		5
#define	DIR_UL		6
#define	DIR_VIEW	7
#define	DIR_MAP		8
#define DIR_SWITCH      9       /* for incremental move, make start=current */
#define	DIR_FIRST	1
#define	DIR_LAST	6

#define	SELL_NOT_DELIV	7                   /* in "_use" field => contract */

extern	int	diroff[][2];
extern	s_char	dirch[];

s_char	*getpath _PROTO((s_char buf[], s_char *arg, coord x, coord y, int onlyown, int showdes, int showxy, int destinations));
double	pathtoxy _PROTO((s_char *path, coord *xp, coord *yp, double (*cost) _PROTO((struct sctstr *sp, natid own))));

double	sector_mcost _PROTO((int type, int effic));
double	ncost _PROTO((struct sctstr *sp, natid own));
double	fcost _PROTO((struct sctstr *sp, natid own));

s_char *BestLandPath _PROTO((s_char path[], struct sctstr *from, struct sctstr *to, double *cost));

#define	P_NONE		0	/* NO destinations allowed */
#define	P_WALKING	1	/* use BestLandPath, only owned */
#define	P_FLYING	2	/* use bestpath, any */
#define	P_SAILING	3	/* use bestpath, any */
#define	P_DISTING	4	/* use BestDistPath, only owned */

#define MAX_PATH_LEN 1024

/* defines needed for bestpath and the incremental move routines */
#define MAXROUTE 100

#endif /* _PATH_H_ */
