/*
 * trade.h
 *
 * defs for "set/trade" commands
 *
 * from PSL Empire, 1985
 * $Revision: 1.6 $ $Date: 89/09/03 16:52:10 $
 */

#ifndef _TRADE_H_
#define _TRADE_H_

#include "genitem.h"
#include "nuke.h"
#include "plane.h"
#include "land.h"
#include "ship.h"

#include "prototype.h"

#define TRADE_DELAY 36000 /*trade delay time in seconds*/

struct trdstr {
        short   ef_type;
	natid	trd_owner;
	short	trd_uid;
	char	trd_type;
	short	trd_unitid;
	long	trd_price;
	int	trd_maxbidder;
	int	trd_maxprice;
	time_t  trd_markettime;
	coord	trd_x;
	coord	trd_y;
};

struct genstr {
        short   trg_ef_type;
	natid   trg_own;
	short   trg_uid;
	coord	trg_x;
	coord	trg_y;
	s_char  trg_type;
};

union trdgenstr {
        struct  genstr gen;
        struct  nukstr nuk;
        struct  plnstr pln;
        struct  lndstr lnd;
        struct  shpstr shp;
};
 
s_char	*trade_nameof _PROTO((struct trdstr *tp, union trdgenstr *tgp));

#define gettrade(n, p) \
	ef_read(EF_TRADE, n, (caddr_t)p)
#define puttrade(n, p) \
	ef_write(EF_TRADE, n, (caddr_t)p)
#define gettradep(n) \
	(struct trdstr *) ef_ptr(EF_TRADE, n)

#endif /* _TRADE_H_ */
