/* testedb.c -- this tests some of the empire database access functions */

#include <stdio.h>

#include "edbproc.h"
#include "edbpriv.h"
#include "misc.h"
#include "file.h"
#include "xy.h"
#include "nsc.h"
#include "genitem.h"
#include "edb.h"
#include "collect.h"

#define BUFSZ 4096

#ifdef SERVERTYPES
char program[] = "makedefs";
#endif

/* these functions are not really supposed to be supported, but may be useful */

Empire_Database *edb = 0;
int debug = 0;

char *defaultInput = "csync.dat";
char *fname = 0;
	
int parseArgs(argc, argp)
	int argc;
	char **argp;
{
	int i;
	char c, *p;
	for (i=1;i<argc;i++) {
		p = argp[i];
		if (*p == '-') {
		    p++;
		    while ((c=*p++)!=0) {
		    	switch (c) {
		    	    case 'd':
		    	    	debug++;
		    	    	break;
		    	    default:
		    	    	perror("bad command line arg");
		    	}
		    }
		}
		else if (fname)
			perror("too many arguments");
		else
		    fname = p;
	}

}

int main(argc, argp)
	int argc;
	char **argp;
{
	FILE *f;
	int lines=0;
	char buf[BUFSZ];
	struct DumpTable *p;

	parseArgs(argc, argp);

	if (!fname) fname = defaultInput;	
	f = fopen(fname,"r+");
	if (!f) {
		perror("cannot open csync.dat");
		exit(1);
	}
	edb = edb_new();
	while (fgets(buf, BUFSZ, f)) {
		edb_parse_c_sync(edb, buf+2);
		lines++;
	}
	fclose(f);


	f = fopen("typedefs.h","w+");
	fprintf(f,"/* generated by makedefs. Do not edit. */\n");
	fprintf(f,"#ifndef __TYPEDEFS_H__\n");
	fprintf(f,"#define __TYPEDEFS_H__\n");
	fprintf(f,"#endif\n");
	edb_dumpHeaders(f,edb);
	fclose(f);
	f = fopen("typedefs.c","w+");
	fprintf(f,"/* generated by makedefs. Do not edit. */\n\n");
	fprintf(f,"#include \"edbsyms.h\"\n\n");
	edb_dumpStructs(f,edb);
	fclose(f);

	return 0;
}
